/**
      SoS (Sense Of Self) // Receiving data from Dweet stream // TeZ 2017
      //  http://dweet.io/
 */

#include <Arduino.h>
#include <ESP8266WiFi.h>
#include <ESP8266WiFiMulti.h>
#include <ESP8266HTTPClient.h>
#define USE_SERIAL Serial

ESP8266WiFiMulti WiFiMulti;
HTTPClient myhttp;

String mydweeter = "http://dweet.io/dweet/for/tezdweet?whatever="; // here you can change tezdweet with your personal channel name

String response;

///////////////////////////////////////////////////
void setup() {

    response = "nada";

    USE_SERIAL.begin(115200);
   // USE_SERIAL.setDebugOutput(true);

    USE_SERIAL.println();
    for(uint8_t t = 4; t > 0; t--) {
        USE_SERIAL.printf("[SETUP] WAIT %d...\n", t);
        USE_SERIAL.flush();
        delay(1000);
    }


    // create newtork connection 
    WiFiMulti.addAP("TheTeZ", "thetez23"); // WiFiMulti.addAP("SSID", "PASSWORD");
  
    delay(1000);


  // wait for WiFi connection
     USE_SERIAL.print("Connecting to local WiFi ");
    while((WiFiMulti.run() != WL_CONNECTED)) {
        USE_SERIAL.print(".");
         delay(500);
    }

    // dweeter.concat("X"); // test concat
  
    USE_SERIAL.println();
    USE_SERIAL.println("YEAH!!  Connected to local WiFi ");
    USE_SERIAL.println();

    delay (1000);
       PostDweet("tezdweet","whatever",23); // first call to init the communication
    delay (2000);
}


///////////////////////////////////////////////////
  void PostDweet(String mychannel, String myparam, float myvalue){

        mydweeter = "http://dweet.io/dweet/for/";//
        mydweeter.concat(mychannel); // here you can change the channel with yours
        mydweeter.concat("?");
        mydweeter.concat(myparam); // here you can change the parameter with your variable
        mydweeter.concat("=");
        mydweeter.concat(myvalue); 
        myhttp.begin(mydweeter); // here connects and POSTs data to DWEET at the same time
        USE_SERIAL.print("POSTed >> "); 
        // USE_SERIAL.println(dweeter);


          // GET SESSION
        // start connection and send HTTP header
        int httpCode = myhttp.GET();
 
        // httpCode will be negative on error
        if(httpCode > 0) {
            // HTTP header has been send and Server response header has been handled
            USE_SERIAL.printf("[HTTP] GET... code: %d\n", httpCode);

            // file found at server
            if(httpCode == HTTP_CODE_OK) {
                String payload = myhttp.getString();
                USE_SERIAL.println(payload);
            }
        } else {
            USE_SERIAL.printf("[HTTP] GET... failed, error: %s\n", myhttp.errorToString(httpCode).c_str());
        }

         
        myhttp.end();


}


///////////////////////////////////////////////////
void GetDweet(String mysensor){

    //   posthttp.begin("http://dweet.io/get/latest/dweet/for/tez-sensor-02"); // here connects to GET DWEET data

          String sensorUrl = "http://dweet.io/get/latest/dweet/for/";
           sensorUrl.concat(mysensor);
       
          myhttp.begin(sensorUrl); // here connects to GET DWEET data
 
        // start connection and send HTTP header
        int httpCode = myhttp.GET();
 
        // httpCode will be negative on error
        if(httpCode > 0) {
            // HTTP header has been send and Server response header has been handled
           // USE_SERIAL.printf("[HTTP] GET... code: %d\n", httpCode);

            // file found at server
            if(httpCode == HTTP_CODE_OK) {
                String payload = myhttp.getString();
                response=payload;
                // USE_SERIAL.println(payload);
            }
        } else {
            USE_SERIAL.printf("[HTTP] GET... failed, error: %s\n", myhttp.errorToString(httpCode).c_str());
        }

       myhttp.end();

}

///////////////////////////////////////////////////
void GetDweetStream(String mysensor){

   
          // https://dweet.io/listen/for/dweets/from/my-thing-name
          String sensorUrl = "http://dweet.io/listen/for/dweets/from/";
           sensorUrl.concat(mysensor);
       
          myhttp.begin(sensorUrl); // here connects to GET DWEET data
 
        // start connection and send HTTP header
        int httpCode = myhttp.GET();
 
        // httpCode will be negative on error
        if(httpCode > 0) {
            // HTTP header has been send and Server response header has been handled
           // USE_SERIAL.printf("[HTTP] GET... code: %d\n", httpCode);

            // file found at server
            if(httpCode == HTTP_CODE_OK) {
                String payload = myhttp.getString();
                response=payload;
                // USE_SERIAL.println(payload);
            }
        } else {
            USE_SERIAL.printf("[HTTP] GET... failed, error: %s\n", myhttp.errorToString(httpCode).c_str());
        }

       myhttp.end();

}




///////////////////////////////////////////////////
void loop() {

/*
      // read channel
      GetDweet("tezdweet"); // here you can change "tezdweet" with your personal channel name 
      Serial.println(response);
      delay(1000);
*/
     //write channel
       
        int r = random(200);
        Serial.print("random num: ");
        Serial.println(r);
        PostDweet("tezdweet","exemp",r); // Use this to POST data from your sensor(s)
        delay(1000);
        

}

